# Spawned

## Installation

```
npm install -s git+ssh://git@git.keywesttechnology.com:keywest/spawned.git
```

## Usage

Import Spawned from the scoped namespace


```
const Spawned = require('@keywest/spawned');
```

### Spawn a process

By default Spawned.spawn() inherits the processes stdout and stderr streams.  If you wish to capture the processes output, provide a stream.Writable to the stdout and stderr parameters of the Spawned.spawn() call.

Spawned.spawn() rejects if the process raises an error or closes with a non-zero exit code, otherwise fulfulls when the process has closed succesfully.

```
await Spawned.spawn('echo', ['hello world']);
```

### Invoking sudo

The Spawned.sudo() function provides a utility interface for invoking sudo.  The first parameter should be the sudoer password (an empty string if there is no password) which will be sent to the sudo command over the child processes stdin pipe.

```
await Spawned.sudo('<sudoerpassword>', 'echo hello');
```

Spawned.sudo will always write a non-empty password to the child processes stdin pipe and calls sudo with the -k switch (which forces sudo to prompt for a password, if one is required.)  However, if you sudo a command that has been configured to not prompt for a password, then you must pass an empty password, otherwise the password will be leaked to the process invoked by sudo.
