async function FeedControl($tag) {
	LockBody();
	try {
		const response = await get('/get/capsfeeds.php');
		CheckSessionExpired(response);
		const feeds = response.data.length > 0 ? JSON.parse(response.data[0].capfeeds) : [];
		
		const render = () => {
			$tag.innerHTML = '';
			$tag.append(
				$.header({ text: 'CAPS Filters' }),
				$.div({ class: 'feed-list formgrid compact' },
					$.header({},
						$.label({ text: 'URL' }),
						$.i({ class: 'tooltip-button mdi mdi-plus-circle-outline', title: 'Add Feed', click: () => {
							feeds.push({
								url: ''
							});
							render();
						} })
					),
					...feeds.map((feed, index) => {
						return [
							$.input({ type: 'text', class: 'sampleInput', placeholder: 'URL', value: feed.url, input: function() { feed.url = this.value; }, change: function() { feed.url = this.value; } }),
							$.i({ class: 'mdi mdi-trash-can-outline tooltip-button delete', title: 'Delete', click: () => {
								feeds.splice(index, 1);
								render();
							} })
						];
					}).flat()
				),
				$.div({ class: 'panel-buttons' },
					$.button({ class: 'primary', text: 'Save', click: async () => {
						LockBody();
						try {
							const response = await post('/post/updatecapsfeeds.php', {
								capsfeeds: JSON.stringify(feeds)
							});
							CheckSessionExpired(response);
							if (response.success) {
								ConfirmationBox('CAPS Feeds Updated', 'CAPS Feeds Updated.');
							}
						} catch (exception) {
							NetworkingError();
						} finally {
							UnlockBody();
						}
					} })
				)
			);
		};
		render();
	} catch (exception) {
		NetworkingError();
	} finally {
		UnlockBody();
	}
}
