function onLoad()
{
	var playerCount = parseInt($('#playercount').val(), 10);
	var playerId = $('#playerid').val();
	playerCount = playerCount + 1;

	$('#screenwidth').val(screen.width);
	$('#screenheight').val(screen.height);
}

function submitPlayerForm(submitType)
{
	var playerId = $('#playerid').val();
	var playerName = $('#name').val();
	var screenWidth = $('#screenwidth').val();
	var screenHeight = $('#screenheight').val();
	var submitButton = submitType;

	//check PlayerName Length
	if ((playerName.length <1) || (playerName.length >80))
	{
		$('#playernameerror').show();
		$('#playernamevalid').hide();
		throw "Player Name must be between 2 and 80 characters";
	}
	else
	{
		$('#playernameerror').hide();
		$('#playernamevalid').show();
	}

	//check the screenWidth length
	if ((screenWidth.length < 2) || (screenWidth.length > 6))
	{
		$('#screenwidtherror').show();
		$('#screenwidthvalid').hide();
		throw "Screen Width must be between 2 and 6 characters";
	}
	else
	{
		$('#screenwidtherror').hide();
		$('#screenwidthvalid').show();
	}

	//check the screenHeight length
	if ((screenHeight.length < 2) || (screenHeight.length > 6))
	{
		$('#screenheighterror').show();
		$('#screenheightvalid').hide();
		throw "Screen Height must be between 2 and 6 characters";
	}
	else
	{
		$('#screenheighterror').hide();
		$('#screenheightvalid').show();
	}

	//check that the player name is alpha numeric (allow spaces)
	if (!isAlphaNumericSpaces(playerName))
	{
		$('#playernameerror').show();
		$('#playernamevalid').hide();
		throw "Invalid Player Name";
	}
	else
	{
		$('#playernameerror').hide();
		$('#playernamevalid').show();
	}

	//check the screenwidth to ensure its a numeric value
	if (!isNumeric(screenWidth))
	{
		$('#screenwidtherror').show();
		$('#screenwidthvalid').hide();
		throw "Screen Width must be numeric";
	}
	else
	{
		$('#screenwidtherror').hide();
		$('#screenwidthvalid').show();
	}

	//check the screenheight to ensure its a numeric value
	if (!isNumeric(screenHeight))
	{
		$('#screenheighterror').show();
		$('#screenheightvalid').hide();
		throw "Screen Height must be numeric";
	}
	else
	{
		$('#screenheighterror').hide();
		$('#screenheightvalid').show();
	}

	$.ajax(
	{
		type: 'POST',
		data:
		{
			playerid: playerId,
			playername: playerName,
			screenwidth: screenWidth,
			screenheight: screenHeight,
			submitbutton: submitButton
		},
		dataType: 'json',
		url: 'post/register.php',
		success: (data, statusText, jqXHR) =>
		{
		},
		error: (jqXHR, textStatus, errorThrown) =>
		{
		}
	});
}