customElements.define('ui-dialog', class extends HTMLElement {
	constructor() {
		super();
		this.attachShadow({mode: 'open'});
		this.shadowRoot.innerHTML = `<style>
:host {
	position: absolute !important;
	background-color: var(--background-color);
	box-shadow: 5px 5px 20px rgb(0 0 0 / 50%);
	display: flex;
	flex-flow: column nowrap;
}
@keyframes blink {
	0% { opacity: 1; }
	16% { opacity: 0.8; }
	32% { opacity: 1; }
	48% { opacity: 0.8; }
	64% { opacity: 1; }
	80% { opacity: 0.8; }
	100% {}
}
:host(.blink) {
	animation: 700ms blink;
}
</style>`;
		this.shadowRoot.append(
			$.slot()
		);
		this.$modal = $.div({ css: {
			position: 'absolute',
			left: 0,
			right: 0,
			top: 0,
			bottom: 0,
			backdropFilter: 'blur(2px)',
			backgroundColor: 'rgb(255 255 255 / 50%)'
		} });
	}
	async options({ modal = false } = {}) {
		if (modal) {
			this.setAttribute('modal', '');
		}
	}
	connectedCallback() {
		this.classList.add('panel');
		if (this.hasAttribute('modal')) {
			this.insertAdjacentElement('beforebegin', this.$modal);
		}
	}
	disconnectedCallback() {
		this.$modal.remove();
	}
});