customElements.define('ui-slider', class extends HTMLElement {
	constructor() {
		super();
	}
	async options({ min = 0, max = 100, step = 1 }) {
		this.min = min;
		this.max = max;
		this.internalValue = 0;
		let startOffsetX;
		const documentPointerMove = e => {
			const thisOffset = $.offset(this);
			let value = Math.max(min, Math.min(max, ((e.pageX - startOffsetX) - thisOffset.left) / this.offsetWidth * (max - min) + min));
			value = Math.round((value - min) / step) * step + min;
			this.value = value;
			this.dispatchEvent(new CustomEvent('change'));
		};
		const documentPointerUp = () => {
			document.removeEventListener('pointermove', documentPointerMove, false);
			document.removeEventListener('pointerup', documentPointerUp, false);
		};
		this.$handle = this.appendChild($.div({ text: `${this.value.toFixed(0)}%`, pointerdown: function(e) {
			const thisOffset = $.offset(this);
			startOffsetX = e.pageX - (thisOffset.left + this.offsetWidth / 2);
			document.addEventListener('pointermove', documentPointerMove, false);
			document.addEventListener('pointerup', documentPointerUp, false);
		} }));
	}
	get value() {
		return this.internalValue;
	}
	set value(value) {
		value = Math.max(this.min, Math.min(this.max, value));
		this.internalValue = value;
		this.$handle.innerText = `${value.toFixed(0)}%`;
		this.$handle.style.left = `${Math.round((value - this.min) / (this.max - this.min) * this.offsetWidth)}px`;
	}
});