function isValidEmail(email) {
	var regex = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
	return regex.test(email);
}

function isValidZIPCode(zip) {
	return /^[0-9]{5}(-[0-9]{4})?$/.test(zip);
}

function isAlpha(str) {
	return /^[A-Za-z]*$/.test(str);
}

function isNumeric(str) {
	return /^[0-9]*$/.test(str);
}

function isAlphaNumeric(str) {
	return /^[A-Za-z0-9]*$/.test(str);
}

function IsAlphaNumericSpacesHyphensUnderscoresApostrophesNotEmptyLessThan60Characters(value) {
	return /^[A-Za-z0-9\-_ ']{1,60}$/.test(value);
}

function IsAlphaNumericSpacesHyphensUnderscoresNotEmptyLessThan60Characters(value) {
	return /^[A-Za-z0-9\-_ ]{1,60}$/.test(value);
}

function IsAlphaNumericSpacesHyphensUnderscoresApostrophesPeriodsNotEmptyLessThan40Characters(value) {
	return /^[A-Za-z0-9\-_ '\.]{1,40}$/.test(value);
}

function isAlphaNumericSpaces(str) {
	return /^[A-Za-z0-9 ]*$/.test(str);
}

function isSignedDecimal(str) {
	var regex = /^[-+]?[0-9]+(\.[0-9]+)?$/;
	return regex.test(str);
}

function isName(str) {
	var regex = /[^a-zA-Z0-9\s\.\,]/g;
	return !regex.test(str);
}

function onlyPositiveIntegers(e) {
	if (e.type == 'keydown') {
		if (!e.ctrlKey && /^[^0-9]$/.test(e.key)) {
			e.preventDefault();
		}
	} else if (e.type == 'paste') {
		e.preventDefault();
		const text = e.clipboardData.getData('text/plain').toLowerCase().replace(/[^0-9]/g, '');
		const originalText = this.value;
		const oldSelectionStart = this.selectionStart;
		this.value = `${originalText.slice(0, this.selectionStart)}${text}${originalText.slice(this.selectionEnd, originalText.length)}`;
		this.selectionStart = oldSelectionStart + text.length;
		this.selectionEnd = oldSelectionStart + text.length;
		this.dispatchEvent(new Event('change'));
	}
}

function onlyInteger(e) {
	if (e.type == 'keydown') {
		if (!e.ctrlKey && /^[^-0-9]$/.test(e.key)) {
			e.preventDefault();
		}
	} else if (e.type == 'paste') {
		e.preventDefault();
		const text = e.clipboardData.getData('text/plain').toLowerCase().replace(/[^-0-9]/g, '');
		const originalText = this.value;
		const oldSelectionStart = this.selectionStart;
		this.value = `${originalText.slice(0, this.selectionStart)}${text}${originalText.slice(this.selectionEnd, originalText.length)}`;
		this.selectionStart = oldSelectionStart + text.length;
		this.selectionEnd = oldSelectionStart + text.length;
		this.dispatchEvent(new Event('change'));
	}
}

function onlyPoundHex(e) {
	if (e.type == 'keydown') {
		if (!e.ctrlKey && /^[^#0-9a-f]$/.test(e.key)) {
			e.preventDefault();
		}
	} else if (e.type == 'paste') {
		e.preventDefault();
		const text = e.clipboardData.getData('text/plain').toLowerCase().replace(/[^#0-9a-f]/g, '');
		const originalText = this.value;
		const oldSelectionStart = this.selectionStart;
		this.value = `${originalText.slice(0, this.selectionStart)}${text}${originalText.slice(this.selectionEnd, originalText.length)}`;
		this.selectionStart = oldSelectionStart + text.length;
		this.selectionEnd = oldSelectionStart + text.length;
		this.dispatchEvent(new Event('change'));
	}
};

function onlyHex(e) {
	if (e.type == 'keydown') {
		if (!e.ctrlKey && /^[^#0-9a-f]$/.test(e.key)) {
			e.preventDefault();
		}
	} else if (e.type == 'paste') {
		e.preventDefault();
		const text = e.clipboardData.getData('text/plain').toLowerCase().replace(/[^0-9a-f]/g, '');
		const originalText = this.value;
		const oldSelectionStart = this.selectionStart;
		this.value = `${originalText.slice(0, this.selectionStart)}${text}${originalText.slice(this.selectionEnd, originalText.length)}`;
		this.selectionStart = oldSelectionStart + text.length;
		this.selectionEnd = oldSelectionStart + text.length;
		this.dispatchEvent(new Event('change'));
	}
};

function secondsToTime(secs) {
    var hours = Math.floor(secs / 3600);
    var divisor_for_minutes = secs % 3600;
    var minutes = Math.floor(divisor_for_minutes / 60);
    var divisor_for_seconds = divisor_for_minutes % 60;
    var seconds = Math.ceil(divisor_for_seconds);
    var obj = {
        "h": hours,
        "m": minutes,
        "s": seconds
    };
    return obj;
}

function pad2(number) {
	return ((number < 10) ? '0' : '') + number;
}
