class ContainerAPI {
	static async QuerySupport(feature) {
		if (feature === 'caching') {
			return false;
		} else if (feature === 'mpv') {
			return false;
		} else if (feature === 'screenshots') {
			return false;
		} else if (feature === 'led') {
			return false;
		} else if (feature === 'videoIn') {
			return false;
		} else if (feature === 'networking') {
			return false;
		} else {
			return null;
		}
	}
	static async RequestScreenshot() {
		// Not supported
	}
	static async RequestThumbnailScreenshot(usableWidth, usableHeight, thumbnailWidth, thumbnailHeight) {
		// Not supported
	}
	static async RequestHardReboot() {
		location.reload(true);
	}
	static async RequestSoftReboot() {
		location.reload();
	}
	static async RequestClearCache() {
		// NYI
		location.reload(true);
	}
	static async RequestPinchToZoom(pinchToZoom) {
		// Not supported
	}
	static async LogVitals() {
		// Not supported
	}
	static async SetFrontLedColor(r, g, b) {
		// Not supported
	}
	static async UnregisteredPlayer() {
		console.log('Deleting local copy of player key, player unregistered on server.');
		document.cookie = 'playerkey=; expires=Thu, 01 Jan 1970 00:00:01 GMT;';
		location.reload();
	}
	static async UpdateTimezone(timezone) {
		// Not supported
	}
	static async CheckIn() {
		// TODO: Implement the container checkin system
	}
	static async NetworkRequest(command) {
		// Not supported
	}
	static async SerialRequest(command) {
		// Not supported
	}
	static async QueryLocalIp() {
		return WebContainer.localIp;
	}
	static async QueryContainerVersion() {
		return `Browser_${WebContainer.serverVersion}`;
	}
	static async QuerySerialNumber() {
		return { serialnumber: 'N/A', serialnumbermodifiedtime: 0 };
	}
	static async QueryContainerType() {
		return WebContainer.type;
	}
	static async QueryRegistration() {
		return WebContainer.registration;
	}
	static async QueryAssetsPath() {
		return `https://${WebContainer.registration.subdomain}.breezedigitalsignage.com/`;
	}
	static async AbortDownload(name, folder) {
		// Not supported
		return null;
	}
	static async DownloadFile(url, name, folder, size) {
		// Not supported
		return null;
	}
	static async SaveFile(data, name, folder) {
		// Not supported
		return null;
	}
	static async DeleteFile(name, folder) {
		// Not supported
		return null;
	}
	static async DeleteFolder(folder) {
		// Not supported
		callback(null);
	}
	static async CacheLoad(name, folder) {
		// Not supported
		return null;
	}
	static async CacheStat(name, folder) {
		// Not supported
		return null;
	}
	static async CacheMd5(name, folder) {
		// Not supported
		return null;
	}
	static async ListFiles(folder) {
		// Not supported
		return null;
	}
	static async CreateVideoIn(playlistElementId, videoSource, sourceId, inputWidth, inputHeight) {
		// Not supported
	}
	static async StopVideoIn(playlistElementId, videoSource, sourceId) {
		// Not supported
	}
	static async PlayVideoIn(playlistUniqueId, videoSource, sourceId, x, y, w, h) {
		// Not supported
	}
	static async PlaylistDestroyed(uniqueId) {
		// Not supported
	}
}
/**
 * @param {!string} key
 * @param {!string} account
 * @param {!boolean} preview
 * @param {!number} startTime
 * @param {!string} hostUrl
 * @param {?string} previewPlaylistName
 * @param {!string} serverVersion
 * @param {!string} localIp
*/
async function WebContainer(key, account, preview, startTime, hostUrl, previewPlaylistName, serverVersion, localIp) {
	WebContainer.type = preview ? 'Preview' : 'Web';
	WebContainer.serverVersion = serverVersion;
	WebContainer.localIp = localIp;
	const url = new URL(hostUrl);
	WebContainer.registration = {
		account,
		subdomain: url.hostname.replace('.breezedigitalsignage.com', ''),
		key
	};
	await LoadScripts();
	window.Messenger = new MessengerPlayer(window);
	WebContainer.messenger = new MessengerContainer(window, window);
	WebContainer.player = new Player(key, {
		account: account,
		hostUrl: hostUrl,
		startTime: startTime
	});
	WebContainer.player.ready(() => {
		WebContainer.player.start(previewPlaylistName);
	});
}