const ContainerMessenger = {
	bus: new EventEmitter(),
	listener: async function(e) {
		if (e.data.type === 'bus') {
			let callback = null;
			if (e.data.token !== undefined) {
				callback = response => {
					this.postBack(e.data.event, e.data.token, response);
				};
			}
			this.bus.emit(e.data.event, e.data.args, callback);
		} else if (e.data.type === 'keyboard') {
			if (process.platform == 'win32') {
				const keyScript = `set shell = CreateObject("WScript.Shell")
shell.SendKeys "{${e.data.data}}"`;
				await fs.writeFile('key.vbs', keyScript, 'utf8');
				const exec = require('child_process').exec;
				exec('start key.vbs');
			} else {
				sendkeys.send(e.data.data);
			}
		}
	},
	initialize: function() {
		this.bus.removeAllListeners();
		window.removeEventListener('message', this.listener.bind(this), false);
		window.addEventListener('message', this.listener.bind(this), false);
	},
	_post: function(o) {
		window.postMessage(o, '*');
	},
	post: function(event, data) {
		this._post({
			type: 'bus',
			event: event,
			data: data
		});
	},
	postBack: function(event, token, response) {
		this._post({
			type: 'bus_response',
			event: event,
			response: response,
			token: token
		});
	}
};
