class Watermark {
	/**
	 * @param {!string} hostUrl
	 */
	constructor(hostUrl) {
		this.div = document.createElement('div');
		this.div.classList.add('watermark');
		Object.assign(this.div.style, {
			width: '100vw',
			height: '100vh',
			overflow: 'hidden',
			pointerEvents: 'none'
		});
		const img = new Image();
		Object.assign(img.style, {
			position: 'relative',
			top: '50%',
			left: '50%',
			width: '80%',
			height: '80%',
			opacity: 0.2,
			transform: 'translate(-50%, -50%) rotate(-15deg)',
			pointerEvents: 'none'
		});
		img.src = `${hostUrl}images/keywest.png`;
		this.div.appendChild(img);
	}

	/**
	 * @param {!HTMLElement} el
	 */
	attach(el) {
		el.appendChild(this.div);
	}

	/**
	 * @param {!string} type
	 * @returns {!boolean}
	 */
	static shouldWatermark(type) {
		return type === 'Web';
	}
}
