class Widgetbuttonsfromcontenttreemetadata extends WidgetBase {
	constructor(options) {
		super(options);
		(async () => {
			if (this.container && this.container.hasOwnProperty('contenttree')) {
				const filteredMedia = this.container.contenttree.filter(node => ApplyFilter(node, this.filters, Array.isArray(this.container.metadata) ? this.container.metadata : []));
				
				if (filteredMedia.length == 0 && this.useusedefaultimage && this.usedefaultimage) {
					filteredMedia.push(this.usedefaultimage);
				}
				
				const imagesToCache = filteredMedia;
				
				const imageCacheURLs = await Promise.all(imagesToCache.map(media => this.container.cacheMediaObject(media)));
				imageCacheURLs.forEach((cacheURL, index) => {
					if (cacheURL) {
						imagesToCache[index].cdnurl = cacheURL;
					}
				});
				const cacheData = await UpdateWidgetCache(filteredMedia, this.mediaid, this.container);
				
				this.tag.classList.add('widget-buttonsfromcontenttreemetadata');
				this.tag.innerHTML = '';
				Object.assign(this.tag.style, {
					margin: `${this.margins}px`,
					justifyContent: this.horizontalalignment
				});
				
				for (let media of filteredMedia) {
					// generated item metadata uses attributeName_(metadata) in the widget.js to supply metadata
					const metadata = media.hasOwnProperty('metadata') ? media.metadata : []
					const button = $.div({ text: this.text_(metadata), css: {
						width: `${this.buttonwidth_(metadata)}px`,
						height: `${this.buttonheight_(metadata)}px`,
						margin: `${this.buttonmargins_(metadata)}px`
					}, click: () =>
					{
						// Propagate generated item metadata to the widgets in the new view
					} });
			
					if (this.theme == 'default') {
						button.classList.add('defaultbutton');
					} else if (this.theme == 'custom' && this.useimage_(metadata) && this.image_(metadata) != null) {
						Object.assign(button.style, {
							borderWidth: this.buttonborderthickness_(metadata),
							borderColor: this.buttonbordercolor_(metadata),
							borderRadius: `${this.buttonborderradius_(metadata)}px`,
							backgroundColor: this.buttonbackgroundcolor_(metadata),
							boxShadow: this.buttondropshadow_(metadata) ? `${this.buttondropshadowleft_(metadata)}px ${this.buttondropshadowtop_(metadata)}px ${this.buttondropshadowblurradius_(metadata)}px ${this.buttondropshadowcolor_(metadata)}` : 'none'
						});
						const img = new Image();
						img.setAttribute('crossOrigin', 'anonymous');
						img.onload = function() {
							if (this.crop_(metadata).split(',').length == 4) {
								const [left, top, width, height] = this.crop_(metadata).split(',').map(value => parseInt(value, 10));
								// Crop the image using a canvas object
								const canvas = $.canvas({ width, height });
								canvas.getContext('2d').drawImage(img, left, top, width, height, 0, 0, width, height);
								image.style.backgroundImage = `url(${canvas.toDataURL()})`;
							} else {
								image.style.backgroundImage = `url(${this.src})`;
							}
						};
						img.src = media.cdnurl;
						switch (this.fillstyle_(metadata)) {
							case 1:
								image.style.backgroundSize = '100% 100%';
								break;
							case 2:
								image.style.backgroundSize = 'cover';
								break;
							case 3:
								image.style.backgroundSize = 'contain';
								break;
						}
					}
					this.tag.append(button);
				}
			}
			this.ready();
		})();
	}
}
