class Widgetce6events extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.ce6Interval = null;
		
		this.tag.classList.add('widget-ce6events');
		this.tag.style.backgroundColor = this.background;
		this.tag.append(
			$.div({ class: 'backgroundimage' }),
			$.div({ class: 'events' })
		);
		if (this.usebackgroundimage && this.backgroundimage) {
			Object.assign(this.tag.querySelector('.backgroundimage').style, {
				backgroundImage: `url('${this.backgroundimage.cdnurl}')`,
				backgroundSize: this.backgroundimagecoverfill ? 'cover' : '100% 100%'
			});
		}
		this.getCE6Events();
		this.ce6Interval = setInterval(this.getCE6Events.bind(this), 5 * 60 * 1000);
	}
	async getCE6Events()
	{
		if (this.TagDeleted()) {
			return;
		}
		let cacheData = await new Promise(async resolve => {
			try {
				const data = await $.http({
					method: 'GET',
					url: (this.container ? this.container.hostUrl.replace(/\/$/, '') : '') + '/get/ce6events.php',
					data: {
						mediaid: this.mediaid
					},
					dataType: 'json'
				}).promise;
				
				if (data.success) {
					data.events.sort((a, b) => moment(a.start).isBefore(moment(b.start)) ? -1 : (moment(a.start).isSame(moment(b.start)) ? 0 : 1));
					resolve({ events: data.events });
				} else {
					resolve(null);
				}
			} catch (exception) {
				resolve(null);
			}
		});
		if (this.TagDeleted()) {
			return;
		}
		cacheData = await UpdateWidgetCache(cacheData, this.mediaid, this.container);
		if (!cacheData.hasOwnProperty('events')) {
			cacheData.events = [];
		}
		let lastDate = '';
		this.tag.querySelector('.events').innerHTML = '';
		for (const event of cacheData.events) {
			if (this.showdate && (lastDate == '' || lastDate != moment(event.start).format('M/D/Y'))) {
				this.tag.querySelector('.events').appendChild(
					$.span({ text: moment(event.start).format('M/D/Y'), class: 'groupby-day', css: {
						color: this.groupbydaycolor,
						fontFamily: `'${this.groupbydayfont}'`,
						fontSize: `${this.groupbydayfontsize}px`
					} })
				);
				lastDate = moment(event.start).format('M/D/Y');
			}
			var formattedDate = `${moment(event.start).format('h:ss a')} - ${moment(event.end).format(lastDate == moment(event.end).format('M/D/Y') ? 'h:ss a' : 'M/D/Y h:ss a')}`;
			if (moment(event.start).format('M/D/Y h:ss a') == moment(event.end).format('M/D/Y h:ss a')) {
				formattedDate = moment(event.start).format('h:ss a');
			}
			this.tag.querySelector('.events').append(
				$.div({ text: formattedDate, class: 'date', hidden: !this.showdate, css: {
					color: this.datecolor,
					fontFamily: `'${this.datefont}'`,
					fontSize: `${this.datefontsize}px`
				} }),
				$.div({ text: event.title, class: 'title', css: {
					color: this.titlecolor,
					fontFamily: `'${this.titlefont}'`,
					fontSize: `${this.titlefontsize}px`
				} }),
				$.div({ text: event.location, class: 'location', hidden: !this.showlocation, css: {
					color: this.locationcolor,
					fontFamily: `'${this.locationfont}'`,
					fontSize: `${this.locationfontsize}px`
				} }),
				$.div({ html: event.description, class: 'description', hidden: !this.showdescription, css: {
					color: this.descriptioncolor,
					fontFamily: `'${this.descriptionfont}'`,
					fontSize: `${this.descriptionfontsize}px`
				} })//,
				//$.img({ src: event.photo })
			);
		}
		this.ready();
	}
	Show() {
	}
	Hide() {
	}
	Destroy() {
		clearInterval(this.ce6Interval);
	}
}
