class Widgetce6leadership extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.ce6Interval = null;
		
		this.tag.classList.add('widget-ce6leadership');
		this.tag.style.backgroundColor = this.background;
		this.tag.append(
			$.div({ class: 'backgroundimage' }),
			$.div({ class: 'leadershipgrid' })
		);
		if (this.usebackgroundimage && this.backgroundimage) {
			Object.assign(this.tag.querySelector('.backgroundimage').style, {
				backgroundImage: `url('${this.backgroundimage.cdnurl}')`,
				backgroundSize: this.backgroundimagecoverfill ? 'cover' : '100% 100%'
			});
		}
		this.getCE6Leadership();
		this.ce6Interval = setInterval(this.getCE6Leadership.bind(this), 2 * 60 * 1000);
	}
	async getCE6Leadership() {
		if (this.TagDeleted()) {
			return;
		}
		var cacheData = await new Promise(async resolve => {
			try {
				const data = await $.http({
					method: 'GET',
					url: (this.container ? this.container.hostUrl.replace(/\/$/, '') : '') + '/get/ce6leadership.php',
					data: {
						mediaid: this.mediaid
					},
					dataType: 'json'
				}).promise;
				
				if (data.success) {
					resolve({ employees: data.employees });
				} else {
					resolve(null);
				}
			} catch (exception) {
				resolve(null);
			}
		});
		if (this.TagDeleted()) {
			return;
		}
		cacheData = await UpdateWidgetCache(cacheData, this.mediaid, this.container);
		if (!cacheData.hasOwnProperty('employees')) {
			cacheData.employees = [];
		}
		const columns = [];
		for (var columnItr = 0; columnItr < this.columns; ++columnItr) {
			columns.push([]);
		}
		columnIndex = 0;
		var maxRows = 0;
		for (const employee of cacheData.employees) {
			columns[columnIndex].push(employee);
			maxRows = Math.max(maxRows, columns[columnIndex++].length);
			columnIndex %= this.columns;
		}
		Object.assign(this.tag.querySelector('.leadershipgrid').style, {
			gridGap: `${this.gridgap}px`,
			gridTemplateColumns: (() => { var s = ''; for (var i = 0; i < this.columns * 2; ++i) { s += 'max-content ' } return s; })(),
			gridTemplateRows: (() => { var s = ''; for (var i = 0; i < maxRows; ++i) { s += '1fr ' } return s; })(),
			width: `calc(100% - ${this.margins * 2}px`,
			height: `calc(100% - ${this.margins * 2}px`,
			margin: `${this.margins}px`
		});
		this.tag.querySelector('.leadershipgrid').innerHTML = '';
		for (var rowIndex = 0; rowIndex < maxRows; ++rowIndex) {
			for (var columnIndex = 0; columnIndex < this.columns; ++columnIndex) {
				var column = columns[columnIndex];
				if (rowIndex >= column.length) {
					continue;
				}
				const employee = column[rowIndex];
				this.tag.querySelector('.leadershipgrid').append(
					$.img({ src: `${employee.photo}?${Math.random() * 100000}`, load: function() {
						Object.assign(this.style, {
							width: `${this.width}px`,
							height: `${this.height}px`
						});
					} }),
					$.div({},
						$.div({ text: employee.name, class: 'name', css: {
							color: this.namecolor,
							fontFamily: `'${this.namefont}'`,
							fontSize: `${this.namefontsize}px`
						} }),
						$.div({ text: employee.title, class: 'title', hidden: !this.showtitle, css: {
							color: this.titlecolor,
							fontFamily: `'${this.titlefont}'`,
							fontSize: `${this.titlefontsize}px`
						} }),
						$.div({ text: employee.phonenumber, class: 'phonenumber', hidden: !this.showphonenumber, css: {
							color: this.phonenumbercolor,
							fontFamily: `'${this.phonenumberfont}'`,
							fontSize: `${this.phonenumberfontsize}px`
						} }),
						$.div({ text: employee.email, class: 'email', hidden: !this.showemail, css: {
							color: this.emailcolor,
							fontFamily: `'${this.emailfont}'`,
							fontSize: `${this.emailfontsize}px`
						} }),
					)
				);
			}
		}
		
		this.ready();
	}
	Show() {
		
	}
	Hide() {
		
	}
	Destroy() {
		clearInterval(this.ce6Interval);
	}
}
