class Widgetdigitalclock extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.tag.classList.add('widget-digitalclock');
		this.tag.innerHTML = '';
		this.tag.append(
			this.$date = $.span({ class: 'digitalclock-date' }),
			this.$time = $.span({ class: 'digitalclock-time' })
		);
		this.tag.style.backgroundColor = this.background;
		for (const $e of this.tag.querySelectorAll('span')) {
			Object.assign($e.style, {
				color: this.foreground,
				fontSize: `${this.fontsize}px`,
				fontFamily: `'${this.font}'`,
				paddingLeft: `${Math.min(this.fontsize / 4, 40)}px`,
				paddingRight: `${Math.min(this.fontsize / 4, 40)}px`
			});
		}
		
		this.digitalClockInterval = null;
		
		this.digitalClockInterval = setInterval(this.update.bind(this), 1000);
		this.update();
		
		this.ready();
	}
	update() {
		if (this.TagDeleted()) {
			return;
		}
		let date = '';
		let time = '';
		const now = this.player.currentTime;
		switch (this.dateformat) {
			case 'M/d/yyyy':
				date = now.format('M/D/YYYY');
				break;
			case 'M/d/yy':
				date = now.format('M/D/YY');
				break;
			case 'MM/dd/yy':
				date = now.format('MM/DD/YY');
				break;
			case 'MM/dd/yyyy':
				date = now.format('MM/DD/YYYY');
				break;
			case 'yy/MM/dd':
				date = now.format('YY/MM/DD');
				break;
			case 'yyyy-MM-dd':
				date = now.format('YYYY-MM-DD');
				break;
			case 'dd-MMM-yy':
				date = now.format('DD-MMM-YY');
				break;
			case 'mmmm dd, yyyy':
				date = now.format('MMMM DD, YYYY');
				break;
			case 'mmm dd, yyyy':
				date = now.format('MMM DD, YYYY');
				break;
			case 'ddd':
				date = now.format('ddd');
				break;
			case 'dddd':
				date = now.format('dddd');
				break;
		}
		
		switch (this.timeformat) {
			case 'h:mm tt':
				time = now.format('h:mm a');
				break;
			case 'hh:mm tt':
				time = now.format('hh:mm a');
				break;
			case 'H:mm':
				time = now.format('H:mm');
				break;
			case 'HH:mm':
				time = now.format('HH:mm');
				break;
			case 'h:mm:ss tt':
				time = now.format('h:mm:ss a');
				break;
			case 'hh:mm:ss tt':
				time = now.format('hh:mm:ss a');
				break;
			case 'H:mm:ss':
				time = now.format('H:mm:ss');
				break;
			case 'HH:mm:ss':
				time = now.format('HH:mm:ss');
				break;
		}
		
		if (this.$date.innerText != date) {
			this.$date.innerText = date;
		}
		
		if (this.$time.innerText != time) {
			this.$time.innerText = time;
		}
	}
	Show() {
		clearInterval(this.digitalClockInterval);
		this.digitalClockInterval = setInterval(this.update.bind(this), 1000);
		this.update();
	}
	Hide() {
		clearInterval(this.digitalClockInterval);
	}
	Destroy() {
		clearInterval(this.digitalClockInterval);
	}
	TimeSync() {
		this.update();
	}
}
