class Widgetgooglemaps extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.openLayersKMLInterval = null;
		
		this.computedLatitude = this.latitude.toString().replace(/\x{00B0}/, '');
		this.computedLongitude = this.longitude.toString().replace(/\x{00B0}/, '');
		
		if (this.computedLatitude[this.computedLatitude.length - 1] == 'N' || this.computedLatitude[this.computedLatitude.length - 1] == 'n') {
			this.computedLatitude = parseFloat(this.computedLatitude.substr(0, this.computedLatitude.length - 1));
		} else if (this.computedLatitude[this.computedLatitude.length - 1] == 'S' || this.computedLatitude[this.computedLatitude.length - 1] == 's') {
			this.computedLatitude = this.computedLatitude.substr(0, this.computedLatitude.length - 1);
			this.computedLatitude = parseFloat(this.computedLatitude) * -1;
		}
		if (this.computedLongitude[this.computedLongitude.length - 1] == 'E' || this.computedLongitude[this.computedLongitude.length - 1] == 'e') {
			this.computedLongitude = parseFloat(this.computedLongitude.substr(0, this.computedLongitude.length - 1));
		} else if (this.computedLongitude[this.computedLongitude.length - 1] == 'W' || this.computedLongitude[this.computedLongitude.length - 1] == 'w') {
			this.computedLongitude = this.computedLongitude.substr(0, this.computedLongitude.length - 1);
			this.computedLongitude = parseFloat(this.computedLongitude) * -1;
		}
		this.computedZoom = this.zoom == '' ? 4 : this.zoom;
		
		if (this.computedLatitude == '' && this.computedLongitude == '') {
			this.computedLatitude = '37.6';
			this.computedLongitude = '-95.665';
		} else if (this.computedLatitude == '') {
			this.computedLatitude = '37.6';
		} else if (this.computedLongitude == '') {
			this.computedLongitude = '-95.665';
		}
		this.olKMLLayers = [];
		
		this.tag.classList.add('widget-googlemaps');
		
		this.Render();
		if (this.provider == 'gm') {
			var maximumAge = this.traffic != -1 || this.refreshinterval != -1 ? 24 * 60 * 60 * 1000 : -1;
			if (this.traffic != -1) {
				maximumAge = Math.min(maximumAge, this.traffic * 60 * 1000);
			}
			if (this.refreshinterval != -1) {
				maximumAge = Math.min(maximumAge, this.refreshinterval * 60 * 1000);
			}
			if (maximumAge != -1) {
				setInterval(() =>
				{
					this.RefreshGoogleMaps();
				}, maximumAge);
			}
		} else {
			if (this.refreshinterval != -1) {
				this.openLayersKMLInterval = setInterval(() => {
					for (const layer of this.olKMLLayers) {
						layer.loaded = false;
						layer.setVisibility(true);
						layer.refresh({ force: true, params: { 'key': Math.random()} });
					}
				}, this.refreshinterval * 60000);
			}
		}
	
		this.ready();
	}
	RefreshGoogleMaps() {
		if (this.apikey != '') {
			var url = this.container ? this.container.hostUrl + 'googlemaps' : '/googlemaps';
			this.tag.background = `url('${url}?apikey=${encodeURIComponent(this.apikey)}&width=${this.width}&height=${this.height}&latitude=${this.computedLatitude}&longitude=${this.computedLongitude}&zoom=${this.computedZoom}&maptype=${this.maptype}&marker=${this.marker}&markertext=${this.markertext}&traffic=${this.traffic}&nearbysearch=${encodeURIComponent(this.nearbysearch)}&key=${this.key}&t=${Date.now()}') no-repeat`;
		}
	}
	async Render() {
		if (this.TagDeleted()) {
			return;
		}
		
		this.tag.innerHTML = '';
		if (this.provider == 'gm') {
			this.RefreshGoogleMaps();
		} else {
			var kmlLayers = await new Promise(async resolve => {
				try {
					const data = await $.http({
						method: 'GET',
						url: (this.container ? this.container.hostUrl.replace(/\/$/, '') : '') + '/get/googlemapdata.php',
						dataType: 'json'
					}).promise;
					resolve(data);
				} catch (exception) {
					resolve([]);
				}
			});
			if (this.TagDeleted()) {
				return;
			}
			this.olKMLLayers = [];
			var map = new ol.Map(
			{
				view: new ol.View(
				{
					center: ol.proj.transform([parseFloat(this.computedLongitude), parseFloat(this.computedLatitude)], 'EPSG:4326', 'EPSG:3857'),
					zoom: this.osmzoom
				}),
				layers:
				[
					new ol.layer.Tile(
					{
						source: new ol.source.XYZ(
						{
							url: 'https://osm.keywesttechnology.com/hot/{z}/{x}/{y}.png'
						})
					}),
					...kmlLayers.map(kmlLayer => {
						var layer = new ol.layer.Vector(
						{
							source: new ol.source.Vector(
							{
								url: kmlLayer,
								format: new ol.KML()
							})
						});
						this.olKMLLayers.push(layer);
						return layer;
					})
				],
				target: this.tag,
				controls: []
			});
		}
	}
	Show() {
		
	}
	Hide() {
		
	}
	Destroy() {
		clearInterval(this.openLayersKMLInterval);
	}
}
