class Widgetmediafrommetadata extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.transitionInterval = null;
		
		this.tag.classList.add('widget-mediafrommetadata');
		this.tag.innerHTML = '';
		Object.assign(this.tag.style, {
			margin: `${this.margins}px`
		});
		this.tag.appendChild(
			this.$mediaContainer = $.div()
		);
		
		(async () => {
			let filteredMedia = [];
			if (this.container && this.container.hasOwnProperty('contenttree')) {
				filteredMedia = this.container.contenttree.filter(node =>  node.type != 1 && ApplyFilter(node, this.filters, Array.isArray(this.container.metadata) ? this.container.metadata : []));
				
				if (this.usedefaultimage && this.defaultimage) {
					filteredMedia.push(this.defaultimage);
				}
				
				const imagesToCache = filteredMedia;
				
				const imageCacheURLs = await Promise.all(imagesToCache.map(media => this.container.cacheMediaObject(media)));
				imageCacheURLs.forEach((cacheURL, index) => {
					if (cacheURL) {
						imagesToCache[index].cdnurl = cacheURL;
					}
				});
				const cacheData = await UpdateWidgetCache(filteredMedia, this.mediaid, this.container);
			} else {
				for (let i = 0; i < 1; ++i) {
					const canvas = $.canvas({
						width: 480,
						height: 480
					});
					const context = canvas.getContext('2d');
					context.fillStyle = 'white';
					context.fillRect(0, 0, canvas.width, canvas.height);
					context.strokeStyle = 'black';
					context.textAlign = 'center';
					context.font = '50px serif';
					context.strokeText(`Image ${i + 1}`, 240, 240);
					filteredMedia.push({
						name: `Image ${i + 1}`,
						type: 2,
						cdnurl: canvas.toDataURL()
					});
				}
			}
			// If any of the media defines an order then sort using that
			if (filteredMedia.some(media => {
					const metadata = media.hasOwnProperty('metadata') ? media.metadata : {};
					return this.mediaorder_(metadata) != 0;
				})) {
				filteredMedia.sort((a, b) => {
					const metadataA = a.hasOwnProperty('metadata') ? a.metadata : {};
					const metadataB = b.hasOwnProperty('metadata') ? b.metadata : {};
					return this.mediaorder_(metadataA) - this.mediaorder_(metadataB);
				});
			} else {
				filteredMedia.sort((a, b) => TreeSort(a.name, b.name));
			}
			
			if (this.usedefaultimage && this.defaultimage && filteredMedia.length != 1) {
				filteredMedia.shift();
			}
			for (const media of filteredMedia) {
				if (this.transitiondelay != 0 || this.$mediaContainer.children.length == 0) {
					switch (media.type) {
						case 2: // Image
							const image = $.div({ hidden: true, css: {
								backgroundImage: `url('${media.cdnurl}')`,
								width: `calc(100% - ${this.margins * 2}px)`,
								height: `calc(100% - ${this.margins * 2}px)`
							} });
							switch (this.fillstyle) {
								case 1:
									image.style.backgroundSize = '100% 100%';
									break;
								case 2:
									image.style.backgroundSize = 'cover';
									break;
								case 3:
									image.style.backgroundSize = 'contain';
									break;
							}
							this.$mediaContainer.append(image);
							break;
						case 3: // Video
								
							break;
					}
				}
			}
			if (this.$mediaContainer.querySelector(':first-child')) {
				this.$mediaContainer.querySelector(':first-child').hidden = false;
			}
			this.ready();
		})();
	}
	Show() {
		if (this.transitiondelay != 0 && this.tag.children.length != 0) {
			this.transitionInterval = setInterval(() => {
				const current = [...this.$mediaContainer.children].find($media => !$media.hidden);
				current.fadeOut('slow');
				if (current.nextElementSibling == null) {
					this.$mediaContainer.querySelector(':first-child').fadeIn('slow');
				} else {
					current.nextElementSibling.fadeIn('slow');
				}
			}, this.transitiondelay * 1000);
		}
	}
	Hide() {
		clearInterval(this.transitionInterval);
	}
	Destroy() {
		clearInterval(this.transitionInterval);
	}
}