class Widgetrsscrawl extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.tag.classList.add('widget-rsscrawl');
		this.tag.style.backgroundColor = this.background;
		
		this.rssCrawlInterval = null;
		this.crawl = new BreezeCrawl(this.tag, this.speed, this.alternativescroll);
		this.crawl.foreground = this.foreground;
		this.crawl.spacer = ' ';
		
		this.computedFilter = this.filter;
		this.computedStart = this.start;
		if (this.computedStart != '') {
			this.computedStart = moment(this.computedStart, 'MM/DD/YYYY');
		} else {
			this.computedFilter = false;
		}
		this.computedEnd = this.end;
		if (this.computedEnd != '') {
			this.computedEnd = moment(this.computedEnd, 'MM/DD/YYYY');
		} else {
			this.computedFilter = false;
		}
		
		this.rssCrawlInterval = setInterval(this.processRssData.bind(this), 10 * 60 * 1000); // 10 minutes
		this.processRssData();
		
		this.ready();
	}
	async processRssData() {
		if (this.TagDeleted()) {
			return;
		}
		
		let cacheData = await new Promise(async resolve => {
			var url = '';
			var data = {};
			if (this.rssfeed == 'useurl') {
				url = `${this.container ? this.container.hostUrl.replace(/\/$/, '') : ''}/get/rssdata.php`;
				data =
				{
					t: Date.now(),
					url: this.url
				};
			} else {
				url = `${this.container ? this.container.hostUrl.replace(/\/$/, '') : ''}/rss/${this.account}/${this.rssfeed.replace('.rss', '')}.rss?t=${Date.now()}`;
			}
			
			try {
				const $xml = await $.http({
					method: 'GET',
					url,
					data,
					dataType: 'xml'
				}).promise;
				var text = '';
				for (const $item of $xml.querySelectorAll('item')) {
					var date = moment($item.querySelector('pubDate').textContent, 'ddd, DD MMM YYYY HH:mm:ss Z');
					if (this.rssfeed == 'useurl' || !this.computedFilter || date.isSameOrAfter(this.computedStart) && date.isSameOrBefore(this.computedEnd.endOf('day'))) {
						var title = $item.querySelector('title').textContent;
						var description = $item.querySelector('description').textContent;
						description = $.div({ html: description }).innerText;
						var pubDate = date.format('M/D/YY');
						text += title + (this.showdate ? ', ' + pubDate : '') + (!this.showtitles ? ': ' + description : '') + '     |     ';
					}
				}
				text = text.replace(/<br>/g, ' ').replace(/[\r\n]+/g, ' ');
				resolve({ text });
			} catch (exception) {
				resolve(null);
			}
		});
		if (this.TagDeleted()) {
			return;
		}
		cacheData = await UpdateWidgetCache(cacheData, this.mediaid, this.container);
		if (!cacheData.hasOwnProperty('text')) {
			cacheData.text = '';
		}
		
		this.crawl.startCrawl(this.width, this.height, cacheData.text, this.fontsize, this.font, !this.editor);
	}
	Show() {
		this.crawl.play();
	}
	Hide() {
		this.crawl.pause();
	}
	Destroy() {
		this.crawl.destroy();
		clearInterval(this.rssCrawlInterval);
	}
}
