class Widgetstockcrawl extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.tag.classList.add('widget-stockcrawl');
		Object.assign(this.tag.style, {
			backgroundColor: this.background
		});
		
		this.stockInterval = null;
		this.crawl = new BreezeCrawl(this.tag, this.speed, this.alternativescroll);
		this.crawl.foreground = this.foreground;
		this.crawl.stock = true;
		this.crawl.spacer = '            ';
		
		this.stockInterval = setInterval(this.stockCrawlTick.bind(this), 15 * 60 * 1000); // 15 minute interval
		this.stockCrawlTick();
		
		this.ready();
	}
	async stockCrawlTick() {
		var cacheData = await new Promise(async (resolve, reject) => {
			try {
				const $xml = await $.http({
					method: 'GET',
					url: (this.container ? this.container.hostUrl.replace(/\/$/, '') : '') + '/get/stockdata.php',
					data: {
						stocks: JSON.stringify(this.text.match(/([a-zA-Z0-9\^\.])+/g))
					},
					dataType: 'xml'
				}).promise;
				var stockSymbol = [];
				var stockCompany = [];
				var stockPrice = [];
				var stockChange = [];
				
				for (const $symbol of $xml.querySelectorAll('symbol')) {
					var tmp = $symbol.getAttribute('data');
					if (tmp != null) {
						stockSymbol.push(tmp);
					}
				}
				
				for (const $company of $xml.querySelectorAll('company')) {
					var tmp = $company.getAttribute('data');
					if (tmp != null) {
						stockCompany.push(tmp);
					}
				}
			
				for (const $last of $xml.querySelectorAll('last')) {
					var tmp = $last.getAttribute('data');
					if (tmp != null) {
						stockPrice.push(tmp);
					}
				}
				
				for (const $change of $xml.querySelectorAll('change')) {
					var tmp = $change.getAttribute('data');
					if (tmp != null) {
						stockChange.push(tmp);
					}
				}
				
				// Company (symbol) price arrowchange <-- format 
				// Ex: Apple Inc. (AAPL) 97.19 ^2.47
				var text = '';
				var i = 0;
				var results = this.text.split(/,/g);
				for (var j = 0; j < results.length; ++j) {
					if (stockCompany[i] !== undefined) {
						if (j > 0) {
							text += '            ';
						}
						text += stockCompany[i] + ' (' + stockSymbol[i] + ') ' + parseFloat(stockPrice[i]).toFixed(2) + ' ' + (parseFloat(stockChange[i]) == 0 ? '<span style="color:gray;">▶</span>' : (parseFloat(stockChange[i])  > 0 ? '<span style="color:green;">▲</span>' : '<span style="color:red;">▼</span>')) + Math.abs(parseFloat(stockChange[i])).toFixed(2);
						++i;
					}
				}
				// Fix a typo from the feed server
				text = text.replace(/Corporatio /g, 'Corporation ');
				
				resolve({ text: text });
			} catch (exception) {
				resolve(null);
			}
		});
		if (this.TagDeleted()) {
			return;
		}
		if (!cacheData.hasOwnProperty('text')) {
			cacheData.text = '';
		}
		
		this.crawl.startCrawl(this.width, this.height, cacheData.text.text, this.fontsize, this.font, !this.editor);
	}
	Show() {
		this.crawl.play();
	}
	Hide() {
		this.crawl.pause();
	}
	Destroy() {
		this.crawl.destroy();
		clearInterval(this.stockInterval);
	}
}
