class Widgetweather extends WidgetBase {
	constructor(options) {
		super(options);
		
		this.weatherInterval = null;
		
		this.weatherInterval = setInterval(this.getWeather.bind(this), 15 * 60 * 1000); // update every 15 minutes
		this.getWeather();
	}
	getConditionIcon(condition, forCurrentDay) {
		var lookup =
		{
			'Moderate or heavy showers of ice pellets': ['weather_rain.png', 'modern_sleet.png'],
			'Light showers of ice pellets': ['weather_rain.png', 'modern_sleet.png'],
			'Moderate or heavy sleet showers': ['weather_rain.png', 'modern_sleet.png'],
			'Light sleet showers': ['weather_rain.png', 'modern_sleet.png'],
			'Torrential rain shower': ['weather_rain.png', 'modern_rain.png'],
			'Moderate or heavy rain shower': ['weather_rain.png', 'modern_rain.png'],
			'Light rain shower': ['weather_rain.png', 'modern_rain.png'],
			'Moderate or heavy sleet': ['weather_rain.png', 'modern_sleet.png'],
			'Light sleet': ['weather_rain.png', 'modern_sleet.png'],
			'Moderate or Heavy freezing rain': ['weather_rain.png', 'modern_sleet.png'],
			'Light freezing rain': ['weather_rain.png', 'modern_sleet.png'],
			'Heavy rain': ['weather_rain.png', 'modern_rain.png'],
			'Heavy rain at times': ['weather_rain.png', 'modern_rain.png'],
			'Moderate rain': ['weather_rain.png', 'modern_rain.png'],
			'Moderate rain at times': ['weather_rain.png', 'modern_rain.png'],
			'Heavy freezing drizzle': ['weather_rain.png', 'modern_sleet.png'],
			'Freezing drizzle': ['weather_rain.png', 'modern_sleet.png'],
			'Light drizzle': ['weather_rain.png', 'modern_rain.png'],
			'Patchy light drizzle': ['weather_rain.png', 'modern_rain.png'],
			'Freezing fog': ['weather_rain.png', 'modern_cloudy.png'],
			'Patchy freezing drizzle nearby': ['weather_rain.png', 'modern_sleet.png'],
			'Patchy sleet nearby': ['weather_rain.png', 'modern_sleet.png'],
			'Mist': ['weather_rain.png', 'modern_rain.png'],
			
			'Moderate or heavy snow in area with thunder': ['weather_snow.png', 'modern_snow.png'],
			'Patchy light snow in area with thunder': ['weather_snow.png', 'modern_snow.png'],
			'Moderate or heavy snow showers': ['weather_snow.png', 'modern_snow.png'],
			'Light snow showers': ['weather_snow.png', 'modern_snow.png'],
			'Ice pellets': ['weather_snow.png', 'modern_sleet.png'],
			'Heavy snow': ['weather_snow.png', 'modern_snow.png'],
			'Patchy heavy snow': ['weather_snow.png', 'modern_snow.png'],
			'Moderate snow': ['weather_snow.png', 'modern_snow.png'],
			'Patchy moderate snow': ['weather_snow.png', 'modern_snow.png'],
			'Light snow': ['weather_snow.png', 'modern_snow.png'],
			'Patchy light snow': ['weather_snow.png', 'modern_snow.png'],
			'Blizzard': ['weather_snow.png', 'modern_snow.png'],
			'Blowing snow': ['weather_snow.png', 'modern_snow.png'],
			'Patchy snow nearby': ['weather_snow.png', 'modern_snow.png'],
			
			'Fog': ['weather_cloudy.png', 'modern_cloudy.png'],
			'Overcast': ['weather_cloudy.png', 'modern_cloudy.png'],
			'Cloudy': ['weather_cloudy.png', 'modern_cloudy.png'],
			'Partly Cloudy': ['weather_cloudy.png', 'modern_suncloud.png'],
			
			'Rain': ['weather_rain.png', 'modern_rain.png'],
			'Light rain': ['weather_sunrain.png', 'modern_sunrain.png'],
			'Patchy light rain': ['weather_sunrain.png', 'modern_sunrain.png'],
			'Patchy rain nearby': ['weather_sunrain.png', 'modern_sunrain.png'],
			'Light rain shower': ['weather_sunrain.png', 'modern_sunrain.png'],
			'Patchy rain possible': ['weather_sunrain.png', 'modern_sunrain.png'],
			'Patchy light rain with thunder': ['weather_storm.png', 'modern_storm.png'],
			
			'Sunny': ['weather_sun.png', 'modern_sunny.png'],
			'Clear': ['weather_sun.png', 'modern_sunny.png'],
			
			'Moderate or heavy rain in area with thunder': ['weather_storm.png', 'modern_storm.png'],
			'Patchy light rain in area with thunder': ['weather_storm.png', 'modern_sunstorm.png'],
			
			'Thundery outbreaks in nearby': ['weather_sunstorm.png', 'modern_sunstorm.png'],
			'Thundery outbreaks possible': ['weather_sunstorm.png', 'weather_sunstorm.png']
		};
		for (const key in lookup) {
			const value = lookup[key];
			delete lookup[key];
			lookup[key.toLowerCase()] = value;
		}
		
		if (this.theme === 'modern') {
			var result = lookup.hasOwnProperty(condition.toLowerCase()) ? lookup[condition.toLowerCase()][1] : null;
			if (forCurrentDay && (moment().isBefore(moment().startOf('day').add(4, 'hour')) || moment().isAfter(moment().startOf('day').add(12 + 9, 'hour')))) {
				if (result == 'modern_sunny.png') {
					result = 'modern_night.png';
				} else if (result == 'modern_suncloud.png') {
					result = 'modern_night_cloud.png';
				} else if (result == 'modern_sunrain.png') {
					result = 'modern_night_rain.png';
				} else if (result == 'modern_sunstorm.png') {
					result = 'modern_night_storm.png';
				}
			}
			return result;
		} else {
			return lookup.hasOwnProperty(condition.toLowerCase()) ? lookup[condition.toLowerCase()][0] : null;
		}
	}
	getFullDay(day) {
		switch (day) {
			case 'Mon':
				return 'Monday';
			case 'Tue':
				return 'Tuesday';
			case 'Wed':
				return 'Wednesday';
			case 'Thu':
				return 'Thursday';
			case 'Fri':
				return 'Friday';
			case 'Sat':
				return 'Saturday';
			case 'Sun':
				return 'Sunday';
			default:
				return '_';
		}
	}
	fahrenheitToCelsius(temp) {
		return this.celsius ? Math.round((temp - 32) / 1.8) : temp;
	}
	printDegreeMark() {
		return this.celsius ? 'C' : 'F';
	}
	async getWeather() {
		if (this.TagDeleted()) {
			return;
		}
		const location = this.widgetData.hasOwnProperty('zipcode') && this.widgetData.zipcode != '' ? this.widgetData.zipcode : this.location;
		
		var cacheData = await new Promise(async resolve => {
			let promise;
			({ xhr: this.xhr, promise } = $.http({
				method: 'GET',
				url: (this.container ? this.container.hostUrl.replace(/\/$/, '') : '') + '/get/weatherdata.php',
				data: {
					location: location,
					celsius: this.celsius
				},
				dataType: 'xml'
			}));
			try {
				const $xml = await promise;
				if ($xml.querySelector('forecast_conditions') == null && ($xml.querySelector('current_conditions') == null || $xml.querySelector('current_conditions').querySelector('temp_f').getAttribute('data') == null)) {
					resolve('nodata');
					return;
				}
				
				const forecast = [];
				for (const $day of $xml.querySelectorAll('forecast_conditions')) {
					const conditionIcon = this.getConditionIcon($day.querySelector('condition').getAttribute('data'), false);
					forecast.push({
						high: this.fahrenheitToCelsius(parseFloat($day.querySelector('high').getAttribute('data'))),
						low: this.fahrenheitToCelsius(parseFloat($day.querySelector('low').getAttribute('data'))),
						condition: $day.querySelector('condition').getAttribute('data'),
						icon: conditionIcon == null ? null : (this.container ? this.container.baseUrl.replace(/\/$/, '') : '') + '/ui/images/weather/' + conditionIcon,
						dayOfWeek: $day.querySelector('day_of_week').getAttribute('data'),
						dayOfWeekLong: this.getFullDay($day.querySelector('day_of_week').getAttribute('data'))
					});
				}
				while (forecast.length < 5) {
					forecast.push({ low: '--', high: '--', condition: '--', dayOfWeek: '--', dayOfWeekLong: '--', icon: null });
				}
				var currentConditions = $xml.querySelector('current_conditions');
				let todayTemp = '--';
				let todayCondition = '';
				let conditionIcon = null;
				if (currentConditions.length != 0 && currentConditions.querySelector('temp_f').getAttribute('data') != '') {
					todayTemp = this.fahrenheitToCelsius(parseFloat(currentConditions.querySelector('temp_f').getAttribute('data')));
					todayCondition = currentConditions.querySelector('condition').getAttribute('data');
					conditionIcon = this.getConditionIcon(currentConditions.querySelector('condition').getAttribute('data'), true);
				}
				resolve({
					city: $xml.querySelector('forecast_information').querySelector('city').getAttribute('data').replace('United States of America,', ''),
					todaytemp: todayTemp,
					todaycondition: todayCondition,
					todayconditionicon: conditionIcon == null ? null : (this.container ? this.container.baseUrl.replace(/\/$/, '') : '') + '/ui/images/weather/' + conditionIcon,
					forecast: forecast
				});
			} catch (exception) {
				resolve(null);
			}
		});
		if (this.TagDeleted()) {
			return;
		}
		this.tag.innerHTML = '';
		this.tag.classList.add('widget-weather');
		Object.assign(this.tag.style,
		{
			fontFamily: `'${this.font}'`,
			color: this.foreground
		});
		if (cacheData === 'nodata') {
			this.tag.appendChild($.div({ text: 'Weather information is currently not available.', css: {
				fontSize: '35px',
				margin: '20px',
				textAlign: 'center'
			} }));
		} else {
			cacheData = await UpdateWidgetCache(cacheData, this.mediaid, this.container);
			if (!cacheData.hasOwnProperty('city') || cacheData.city == '') {
				cacheData.city = 'No Data for Location or No Connection';
			}
			if (!cacheData.hasOwnProperty('todaytemp') || cacheData.todaytemp == '') {
				cacheData.todaytemp = '--';
			}
			if (!cacheData.hasOwnProperty('todaycondition') || cacheData.todaycondition == '') {
				cacheData.todaycondition = '--';
			}
			if (!cacheData.hasOwnProperty('forecast') || cacheData.forecast.length < 4) {
				cacheData.forecast = [
					{ low: '--', high: '--', condition: '--', dayOfWeek: '--', dayOfWeekLong: '--', icon: null },
					{ low: '--', high: '--', condition: '--', dayOfWeek: '--', dayOfWeekLong: '--', icon: null },
					{ low: '--', high: '--', condition: '--', dayOfWeek: '--', dayOfWeekLong: '--', icon: null },
					{ low: '--', high: '--', condition: '--', dayOfWeek: '--', dayOfWeekLong: '--', icon: null }
				];
			}
			
			let dimension = Math.min(this.width, this.height);
			let modernScale = 1;
			const hardcodedWidth = 239 + 40;
			const hardcodedHeight = 930;
			if (this.width / hardcodedWidth < this.height / hardcodedHeight) {
				modernScale = this.width / hardcodedWidth;
			} else {
				modernScale = this.height / hardcodedHeight;
			}
			const halfWidthSpace = Math.max(0, Math.round((this.width - (hardcodedWidth - 40) * modernScale) / 2));
			const halfHeightSpace = Math.max(0, Math.round((this.height - hardcodedHeight * modernScale) / 2));
			
			if (this.theme == 'default') {
				this.tag.appendChild(
					$.div({ class: 'largeSquare', css: {
						width: `${dimension}px`,
						height: `${dimension}px`
					} },
						$.img({ class: 'forecast-current-icon', src: cacheData.todayconditionicon ? cacheData.todayconditionicon : '', css: {
							width: `${Math.round(80 / 200 * dimension)}px`,
							height: `${Math.round(80 / 200 * dimension)}px`,
							paddingRight: `${Math.round(7 / 200 * dimension)}px`
						} }),
						$.div({ class: 'square-background-gradient', css: {
							borderRadius: `${Math.round(8 / 200 * dimension)}px`,
							background: `linear-gradient(${this.backgrounddirection},${this.backgroundprimarycolor == '' ? 'transparent' : this.backgroundprimarycolor},${this.backgroundsecondarycolor == '' ? 'transparent' : this.backgroundsecondarycolor})`
						} },
							$.div({ class: 'forecast-current-temp', html: `${cacheData.todaytemp}&deg;${this.printDegreeMark()}`, css: {
								fontSize: `${Math.round(40 / 200 * dimension)}px`,
								paddingLeft: `${Math.round(10 / 200 * dimension)}px`
							} }),
							$.div({ class: 'forecast-container', css: {
								paddingLeft: `${Math.round(30 / 200 * dimension)}px`,
							} }, ...cacheData.forecast.slice(1, 4).map(forecastDay => $.div({ class: 'forecast-33-container', css: {
									width: `${Math.round(45 / 200 * dimension)}px`,
									height: `${Math.round(50 / 200 * dimension)}px`,
									paddingLeft: `${Math.round(5 / 200 * dimension)}px`,
									top: `${Math.round(16 / 200 * dimension)}px`
								} },
									$.div({ class: 'forecast-day-name', text: forecastDay.dayOfWeek, css: {
										fontSize: `${Math.round(15 / 200 * dimension)}px`
									} }),
									$.div({ class: 'forecast-day-icon' },
										$.img({ src: forecastDay.icon ? forecastDay.icon : '', css: {
											width: `${Math.round(30 / 200 * dimension)}px`,
											height: `${Math.round(30 / 200 * dimension)}px`
										} }),
										$.div({ class: 'square-forecast-hi-low-1 forecast-day-hi-lo', css: {
											fontSize: `${Math.round(10 / 200 * dimension)}px`
										} },
											$.b({ html: `${forecastDay.high}&deg;` }),
											$.div({ html: `|${forecastDay.low}&deg;` }).innerText
										)
									)
								))
							),
							$.div({ class: 'forecast-bottom' },
								$.div({ class: 'forecast-location', text: cacheData.city, css: {
									fontSize: `${Math.round(13 / 200 * dimension)}px`
								} }),
								$.div({ class: 'forecast-current-hi-lo', css: {
									fontSize: `${Math.round(13 / 200 * dimension)}px`
								} },
									$.b({ html: `${cacheData.forecast[0].high}&deg;` }),
									$.div({ html: `|${cacheData.forecast[0].low}&deg;` }).innerText
								)
							)
						)
					)
				);
			} else if (this.theme == 'modern') {
				this.tag.appendChild(
					$.div({ class: 'modern_container', css: {
						transform: `translate(${halfWidthSpace}px, ${halfHeightSpace}px) scale(${modernScale})`,
						background: `linear-gradient(${this.backgrounddirection},${this.backgroundprimarycolor == '' ? 'transparent' : this.backgroundprimarycolor},${this.backgroundsecondarycolor == '' ? 'transparent' : this.backgroundsecondarycolor})`
					} },
						$.img({ src: cacheData.todayconditionicon ? cacheData.todayconditionicon : '', class: 'modern_current_icon' }),
						$.p({ html: `${cacheData.todaytemp}&deg;${this.printDegreeMark()}`, class: 'modern_current_temp' }),
						$.p({ html: `<b>${cacheData.forecast[0].high}&deg;</b>/${cacheData.forecast[0].low}&deg;`, class: 'modern_current_hi_lo' }),
						$.div({ class: 'modern-separator' }),
						...cacheData.forecast.slice(1, 4).map(forecastDay => {
							return [
								$.div({ class: 'modern_forecast' },
									$.p({ text: forecastDay.dayOfWeekLong, class: 'modern_forecast_day' }),
									$.div({ class: 'modern_forecast_hi_lo_div' },
										$.img({ src: forecastDay.icon ? forecastDay.icon : '', class: 'modern_forecast_img' }),
										$.span({ html: `<b>${forecastDay.high}&deg;</b>/${forecastDay.low}&deg;`, class: 'modern_forecast_hi_lo' })
									)
								),
								$.div({ class: 'modern-separator' })
							];
						}).flat(),
						$.p({ text: cacheData.city, class: 'modern_location' })
					)
				);
			}
			
			for (const $element of this.tag.querySelectorAll('.modern_forecast_hi_lo')) {
				$element.style.fontSize = `${Math.max(Math.min($element.offsetWidth / 10, 25), 22)}pt`;
			}
		}
		this.ready();
	}
	Destroy() {
		if (this.xhr) {
			this.xhr.abort();
		}
		clearInterval(this.weatherInterval);
	}
}
