## Note: This is a work in progress. Beats should not be installed on regular clients' players until the monitoring
##       server is secured. Also, the actual zip files should be downloaded from a Keywest controlled location (rackspace?)

$beat_home="C:\breeze\scripts\beats"
[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12


#### FILEBEAT ####
# install and configure filebeat
$beat_dir="C:\Program Files\filebeat"
Remove-Item -Path $beat_dir -Recurse -Force
New-Item -ItemType "directory" -Path $beat_dir -Force
Set-Location -Path $beat_dir

Invoke-WebRequest -Uri "https://artifacts.elastic.co/downloads/beats/filebeat/filebeat-6.8.6-windows-x86_64.zip" -OutFile $beat_dir\filebeat-6.8.6-windows-x86_64.zip
Expand-Archive -Path filebeat-6.8.6-windows-x86_64.zip -DestinationPath $beat_dir -Force
Move-Item -Path $beat_dir\filebeat-6.8.6-windows-x86_64\* -Destination $beat_dir\ -Force

Rename-Item -Path $beat_dir\filebeat.yml $beat_dir\filebeat.yml.orig -Force
Copy-Item $beat_home\filebeat.yml.config -Destination $beat_dir\filebeat.yml -Force

# Start filebeat and add it to run as a service
& "$beat_dir\install-service-filebeat.ps1"


#### METRICBEAT ####
# install and configure metricbeat
$beat_dir="C:\Program Files\metricbeat"
Remove-Item -Path $beat_dir -Recurse -Force
New-Item -ItemType "directory" -Path $beat_dir -Force
Set-Location -Path $beat_dir

Invoke-WebRequest -Uri "https://artifacts.elastic.co/downloads/beats/metricbeat/metricbeat-6.8.6-windows-x86_64.zip" -OutFile $beat_dir\metricbeat-6.8.6-windows-x86_64.zip
Expand-Archive -Path metricbeat-6.8.6-windows-x86_64.zip -DestinationPath $beat_dir -Force
Move-Item -Path $beat_dir\metricbeat-6.8.6-windows-x86_64\* -Destination $beat_dir\ -Force

Rename-Item -Path $beat_dir\metricbeat.yml $beat_dir\metricbeat.yml.orig -Force
Copy-Item $beat_home\metricbeat.yml.config -Destination $beat_dir\metricbeat.yml -Force

# Start metricbeat and add it to run as a service
& "$beat_dir\install-service-metricbeat.ps1"


#### PACKETBEAT ####
# install and configure packetbeat
$beat_dir="C:\Program Files\packetbeat"
Remove-Item -Path $beat_dir -Recurse -Force
New-Item -ItemType "directory" -Path $beat_dir -Force
Set-Location -Path $beat_dir

Invoke-WebRequest -Uri "https://artifacts.elastic.co/downloads/beats/packetbeat/packetbeat-6.8.6-windows-x86_64.zip" -OutFile $beat_dir\packetbeat-6.8.6-windows-x86_64.zip
Expand-Archive -Path packetbeat-6.8.6-windows-x86_64.zip -DestinationPath $beat_dir -Force
Move-Item -Path $beat_dir\packetbeat-6.8.6-windows-x86_64\* -Destination $beat_dir\ -Force

Rename-Item -Path $beat_dir\packetbeat.yml $beat_dir\packetbeat.yml.orig -Force
Copy-Item $beat_home\packetbeat.yml.config -Destination $beat_dir\packetbeat.yml -Force
$ymlfile = "$beat_dir\packetbeat.yml"
((Get-Content -path $ymlfile -Raw) -replace 'packetbeat.interfaces.device: any','packetbeat.interfaces.device: 1') | Set-Content -Path $ymlfile


# Start packetbeat and add it to run as a service
& "$beat_dir\install-service-packetbeat.ps1"


#### WINLOGBEAT ####
# install and configure winlogbeat
$beat_dir="C:\Program Files\winlogbeat"
Remove-Item -Path $beat_dir -Recurse -Force
New-Item -ItemType "directory" -Path $beat_dir -Force
Set-Location -Path $beat_dir

Invoke-WebRequest -Uri "https://artifacts.elastic.co/downloads/beats/winlogbeat/winlogbeat-6.8.6-windows-x86_64.zip" -OutFile $beat_dir\winlogbeat-6.8.6-windows-x86_64.zip
Expand-Archive -Path winlogbeat-6.8.6-windows-x86_64.zip -DestinationPath $beat_dir -Force
Move-Item -Path $beat_dir\winlogbeat-6.8.6-windows-x86_64\* -Destination $beat_dir\ -Force

Rename-Item -Path $beat_dir\winlogbeat.yml $beat_dir\winlogbeat.yml.orig -Force
Copy-Item $beat_home\winlogbeat.yml.config -Destination $beat_dir\winlogbeat.yml -Force

# Start winlogbeat and add it to run as a service
& "$beat_dir\install-service-winlogbeat.ps1"

