$scriptDirectory = Split-Path -Parent $MyInvocation.MyCommand.Definition
. "$scriptDirectory/common.ps1"

ensureAdmin

# Force TLS 1.2
[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12

# Run the Breeze 2.x uninstaller for a clean install
Write-Output "Running the uninstaller for a clean install..."
& "$scriptDirectory/uninstaller.ps1"

Write-Output "Installing Breeze..."

Write-Output "Extracting version from current working directory..."

$updateDirectory -match '(_?[0-9]+_?){3,4}'
$versionString = $matches[0]
$versionString = $versionString.Replace("_", ".")
Write-Output "Version: $versionString"
$versionString = '"' + $versionString + '"'

# Create the top-level directories
New-Item -Force -ItemType directory -Path $rootPath
New-Item -Force -ItemType directory -Path $containerPath
New-Item -Force -ItemType directory -Path $logPath

installNode
installNwjs
CopyFiles
CreateWatchdog
CreateShortcuts
OptimizingPowershell

Write-Output "Writing version to file..."
SaveFile $versionPath $versionString

Write-Output "Finished, please check the above output for errors."
