$scriptDirectory = Split-Path -Parent $MyInvocation.MyCommand.Definition
. "$scriptDirectory/common.ps1"

# Old versions of Breeze do not generate an update.lock file
if (!$(Test-Path $updateLockPath)) {
	# Infer the current patch version and create and update.lock file
	# The version number is in the $updateDirectory as ../config/updates/xx_xx_xx_xx/..
	$updateDirectory -match 'updates\\(_?[0-9]+_?){3,4}'
	$versionString = $matches[0]
	$versionString = $versionString.Replace("updates\", "")
	$versionString = $versionString.Replace("_", ".'")
	$versionString = $versionString.Replace("'", "")
	$versionString = '"' + $versionString + '"'
	Out-File -Filepath $updateLockPath -InputObject $versionString -Encoding ASCII

	# Try to kill breeze
	Stop-Process -Name "nw" -ErrorAction SilentlyContinue
	Start-Sleep -s 1
}

# Try to wait for NWJS to end on its own. After a minute give up and try to kill it
$killNwjs = $true
for ($itr = 0; $itr -le 10; ++$itr) {
	Get-Process nw
	if ($?) {
		Start-Sleep -s 6
	} else {
		$killNwjs = $false
		break
	}
}
if ($killNwjs) {
	# Hope for the best
	Stop-Process -Name "nw" -ErrorAction SilentlyContinue
	Start-Sleep -s 1
}

$version = "00.00.00"
if (Test-Path $versionPath) {
	$version = Get-Content $versionPath | Out-String
	$version = $version.Replace('"', '')
}

installNode
installNwjs
CopyFiles
CreateWatchdog
CreateShortcuts
OptimizingPowershell

# Update the version.json file to the latest version (stored in the update.lock file)
New-Item -Force -ItemType directory -Path $configDirectory
DeleteFile $versionPath
Copy-Item $updateLockPath -Destination $versionPath

# Remove the update.lock file and re-launch breeze
DeleteFile $updateLockPath

Start-Process -WindowStyle Hidden PowerShell.exe -Args "-WindowStyle Hidden $watchdogPath"
